/*
 * heat1d-e-glsc.c -- 1ǮƳνͶ۲ˡǲ򤯡
 *   ѥ:  ccmg heat1d-e-glsc.c
 *
 * ꥸʥ fplot 饤֥ꥣѤ
 *  http://www.math.meiji.ac.jp/%7Emk/program/fdm/heat1d-e.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define G_DOUBLE
#include <glsc.h>

int main()
{
  int i, n, nMax, N;
  double tau, h, lambda, Tmax;
  double *u, *newu;
  double f(double);
  double win_width, win_height, w_margin, h_margin;
  char message[100];

  /* N,  Ϥ */
  printf("֤ʬ N = "); scanf("%d", &N);
  printf(" (=/h^2) = "); scanf("%lf", &lambda);

  /* h,  ׻ */
  h = 1.0 / N;
  tau = lambda * h * h;
  printf("=%g\n", tau);

  /* ǽϤ */
  printf("ǽ Tmax = "); scanf("%lf", &Tmax);

  /* ٥ȥ u, newu Ѱդ */
  u = malloc(sizeof(double) * (N+1));
  newu = malloc(sizeof(double) * (N+1));
  
  /* ͤ */
  for (i = 0; i <= N; i++)
    u[i] = f(i * h);

  /* ***************** եåν ***************** */
  /* ᥿ե̾ "HEAT",
   * ɥΥϡ
       win_width  + 2 * w_margin,  win_height + 2 * h_margin */
  win_width = 200.0; win_height = 200.0; w_margin = 10.0; h_margin = 10.0;
  g_init("HEAT", win_width  + 2 * w_margin, win_height + 2 * h_margin);
  /* ̤ȥ᥿եξ˵Ͽ */
  g_device(G_BOTH);
  /* ɸϤ: [-0.1,1.1][-0.1,1.1] Ȥΰɽ */
  g_def_scale(0,
              -0.1, 1.1, -0.1, 1.1,
              w_margin, h_margin, win_width, win_height);
  /* Ѱդ */
  g_def_line(0, G_BLACK, 0, G_LINE_SOLID);
  g_def_line(1, G_BLACK, 0, G_LINE_DOTS);
  /* ɽ뤿ʸ° */
  g_def_text(0, G_BLACK, 3);
  /* Τ򤹤 */
  g_sel_scale(0); g_sel_line(0); g_sel_text(0);

  /* ȥϥѥ᡼ɽ */
  g_text(30.0, 30.0,
         "heat equation, homogeneous Dirichlet boundary condition");
  sprintf(message, "N=%d, lambda=%g, Tmax=%g", N, lambda, Tmax);
  g_text(30.0, 60.0, message);

  /* ɸɽ */
  g_sel_line(1);
  g_move(-0.1, 0.0); g_plot(1.1, 0.0);
  g_move(0.0, -0.1); g_plot(0.0, 1.1);
  g_sel_line(0);

  /* t=0 ξ֤ɽ */
  g_move(0.0, u[0]);
  for (i = 1; i <= N; i++)
    g_plot(i * h, u[i]);

  /* 롼פ򲿲ޤ뤫׻ (ͼθ) */
  nMax = rint(Tmax / tau);

  /* ֤˴ؤ륹ƥåפʤ롼 */
  for (n = 0; n < nMax; n++) {
    /* ʬ (n -> n+1) */
    for (i = 1; i < N; i++)
      newu[i] = (1.0 - 2 * lambda) * u[i] + lambda * (u[i+1] + u[i-1]);
    /* ׻ͤ򹹿 */
    for (i = 1; i < N; i++)
      u[i] = newu[i];
    /* Dirichlet  */
    u[0] = u[N] = 0.0;
    /* λ (t=(n+1)) ξ֤ɽ */
    g_move(0.0, u[0]);
    for (i = 1; i <= N; i++)
      g_plot(i * h, u[i]);
  }
  
  printf("ޤX ξϥɥ򥯥åƲ\n");
  g_sleep(-1.0);
  /* ɥĤ */
  g_term();
  return 0;
}

double f(double x)
{
  if (x <= 0.5)
    return x;
  else
    return 1.0 - x;
}
