/* trid-lu.c -- 3 Gauss ξõˡǲ */

#include "trid-lu.h"

/* 3 (󤬻гѤǤϢΩ1Τ) Ax=b 
 *
 *   
 *     n: ̤οθĿ
 *     al,ad,au: ϢΩ1η
 *       (al: гβ¦ i.e. ʬ (lower part)
 *        ad: г       i.e. гʬ (diagonal part)
 *        au: гξ¦ i.e. 廰ʬ (upper part)
 *        Ĥޤ
 *
 *         ad[0] au[0]   0   .................. 0
 *         al[1] ad[1] au[1]   0  ............. 0
 *           0   al[2] ad[2] au[2]  0 ......... 0
 *                         ....................
 *                         al[n-2] ad[n-2] au[n-2]
 *                           0     al[n-1] ad[n-1]

 *        al[i] = A_{i,i-1}, ad[i] = A_{i,i}, au[i] = A_{i,i+1},
 *        al[0], au[n-1] ϰ̣ʤ)
 *
 *     b: ϢΩ1αդδΥ٥ȥ
 *        (ź 0 顣i.e. b[0],b[1],...,b[n-1] ˥ǡäƤ롣)
 *   
 *     al,ad,au: Ϥ LU ʬ򤷤
 *     b: ϢΩ1β
 *   ǽ
 *      call ȷ LU ʬ򤷤Τ֤Τǡ
 *     ʸƱ˴ؤϢΩ1򤯤ˡ
 *     ؿ trisol() Ȥ롣
 *   
 *     Gauss ξõˡѤƤ뤬ԥܥåȤϤƤ
 *     ΤǡԥܥåȤ򤷤ƤʤΤǡͤǤ
 *     ʤɤŬڤʾ郎ʤϷ̤ݾڤǤʤ
 */

void trid(int n, double *al, double *ad, double *au, double *b)
{
  trilu(n,al,ad,au);
  trisol(n,al,ad,au,b);
}

/* гѹ LU ʬ (pivoting ʤ) */
void trilu(int n, double *al, double *ad, double *au)
{
  int i, nm1 = n - 1;
  /* ʾõ (forward elimination) */
  for (i = 0; i < nm1; i++) {
    al[i + 1] /= ad[i];
    ad[i + 1] -= au[i] * al[i + 1];
  }
}

/* LU ʬѤߤλгѹ򷸿˻3 */
void trisol(int n, double *al, double *ad, double *au, double *b)
{
  int i, nm1 = n - 1;
  /* ʾõ (forward elimination) */
  for (i = 0; i < nm1; i++) b[i + 1] -= b[i] * al[i + 1];
  /*  (backward substitution) */
  b[nm1] /= ad[nm1];
  for (i = n - 2; i >= 0; i--) b[i] = (b[i] - au[i] * b[i + 1]) / ad[i];
}
